From: "Benda XU" <heroxbd@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: dev-util/hip/
Date: Wed, 20 Jan 2021 05:36:24 +0000 (UTC) [thread overview]
Message-ID: <1611118312.8837056f58be66a4bc0cad115f66264fb8e066d7.heroxbd@gentoo> (raw)
commit: 8837056f58be66a4bc0cad115f66264fb8e066d7
Author: Benda Xu <heroxbd <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 19 12:53:28 2021 +0000
Commit: Benda XU <heroxbd <AT> gentoo <DOT> org>
CommitDate: Wed Jan 20 04:51:52 2021 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=8837056f
dev-util/hip: replace hcc with rocclr.
hcc is deprecated and rocclr is the mainstream. Replace remaining hcc
in run_hipcc.cmake and hipcc. This also enables --genco support, which
will be essential in building e.g. Tensile.
Fix trailing - in HIP_LIB_VERSION_STRING by imposing Gentoo version.
Let cmake use the correct HIP_CLANG_INCLUDE_PATH for llvm-roc.
Suggested-by: Yiyang Wu <xgreenlandforwyy <AT> gmail.com>
Closes: https://bugs.gentoo.org/733794
Package-Manager: Portage-3.0.12, Repoman-3.0.1
Signed-off-by: Benda Xu <heroxbd <AT> gentoo.org>
dev-util/hip/hip-4.0.0-r1.ebuild | 116 +++++++++++++++++++++++++++++++++++++++
1 file changed, 116 insertions(+)
diff --git a/dev-util/hip/hip-4.0.0-r1.ebuild b/dev-util/hip/hip-4.0.0-r1.ebuild
new file mode 100644
index 00000000000..9252cfffc77
--- /dev/null
+++ b/dev-util/hip/hip-4.0.0-r1.ebuild
@@ -0,0 +1,116 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+inherit cmake flag-o-matic prefix
+
+DESCRIPTION="C++ Heterogeneous-Compute Interface for Portability"
+HOMEPAGE="https://github.com/ROCm-Developer-Tools/HIP"
+SRC_URI="https://github.com/ROCm-Developer-Tools/HIP/archive/rocm-${PV}.tar.gz -> rocm-hip-${PV}.tar.gz"
+
+KEYWORDS="~amd64"
+LICENSE="MIT"
+SLOT="0/$(ver_cut 1-2)"
+
+IUSE="debug profile"
+
+# Don't strip to prevent some tests from failing.
+RESTRICT="strip"
+
+DEPEND=">=dev-libs/rocclr-$(ver_cut 1-2)
+ >=dev-util/rocminfo-$(ver_cut 1-2)
+ =sys-devel/llvm-roc-${PV}*[runtime]"
+RDEPEND="${DEPEND}"
+
+PATCHES=(
+ "${FILESDIR}/${PN}-3.9.0-DisableTest.patch"
+ "${FILESDIR}/${PN}-3.9.0-add-include-directories.patch"
+ "${FILESDIR}/${PN}-3.5.1-config-cmake-in.patch"
+ "${FILESDIR}/${PN}-3.5.1-hip_vector_types.patch"
+ "${FILESDIR}/${PN}-3.5.1-detect_offload-arch_for_clang-roc.patch"
+ "${FILESDIR}/${PN}-3.9.0-lpl_ca-add-include.patch"
+)
+
+S="${WORKDIR}/HIP-rocm-${PV}"
+
+src_prepare() {
+ cmake_src_prepare
+ eapply_user
+
+ # Use Gentoo version number, otherwise git hash is attempted in vain.
+ sed -e "/set (HIP_LIB_VERSION_STRING/cset (HIP_LIB_VERSION_STRING ${PVR})" -i CMakeLists.txt || die
+
+ # disable PCH, because it results in a build error in ROCm 4.0.0
+ sed -e "s:option(__HIP_ENABLE_PCH:#option(__HIP_ENABLE_PCH:" -i "${S}/CMakeLists.txt" || die
+
+ # "hcc" is deprecated and not installed, new platform is "rocclr";
+ # Setting HSA_PATH to "/usr" results in setting "-isystem /usr/include"
+ # which makes "stdlib.h" not found when using "#include_next" in header files;
+ sed -e "/HIP_PLATFORM.*HIP_COMPILER.*clang/s:hcc:rocclr:" \
+ -e "/FLAGS .= \" -isystem \$HSA_PATH/d" \
+ -e "s:\$ENV{'DEVICE_LIB_PATH'}:'/usr/lib/amdgcn/bitcode':" \
+ -i bin/hipcc || die
+
+ # replace hcc remnants with modern rocclr.
+ sed -e "/HIP_PLATFORM.*STREQUAL/s:hcc:rocclr:" -i cmake/FindHIP/run_hipcc.cmake || die
+
+ # correctly find HIP_CLANG_INCLUDE_PATH using cmake
+ sed -e "/set(HIP_CLANG_ROOT/s:\"\${ROCM_PATH}/llvm\":/usr/lib/llvm/roc:" -i hip-config.cmake.in || die
+
+ # change --hip-device-lib-path to "/usr/lib/amdgcn/bitcode", must align with "dev-libs/rocm-device-libs"
+ sed -e "s:\${AMD_DEVICE_LIBS_PREFIX}/lib:/usr/lib/amdgcn/bitcode:" \
+ -i "${S}/hip-config.cmake.in" || die
+
+ einfo "prefixing hipcc and its utils..."
+ hprefixify $(grep -rl --exclude-dir=build/ "/usr" "${S}")
+}
+
+src_configure() {
+ strip-flags
+ if ! use debug; then
+ append-cflags "-DNDEBUG"
+ append-cxxflags "-DNDEBUG"
+ buildtype="Release"
+ else
+ buildtype="Debug"
+ fi
+
+ # TODO: Currently a GENTOO configuration is build,
+ # this is also used in the cmake configuration files
+ # which will be installed to find HIP;
+ # Other ROCm packages expect a "RELEASE" configuration,
+ # see "hipBLAS"
+ local mycmakeargs=(
+ -DCMAKE_PREFIX_PATH="${EPREFIX}/usr/lib/llvm/roc"
+ -DCMAKE_BUILD_TYPE=${buildtype}
+ -DCMAKE_INSTALL_PREFIX="${EPREFIX}/usr/lib/hip"
+ -DBUILD_HIPIFY_CLANG=OFF
+ -DHIP_PLATFORM=rocclr
+ -DHIP_RUNTIME=ROCclr
+ -DHIP_COMPILER=clang
+ -DROCM_PATH="${EPREFIX}/usr"
+ -DHSA_PATH="${EPREFIX}/usr"
+ -DUSE_PROF_API=$(usex profile 1 0)
+ -DROCclr_DIR="${EPREFIX}"/usr/include/rocclr
+ )
+
+ cmake_src_configure
+}
+
+src_install() {
+ echo "HSA_PATH=${EPREFIX}/usr" > 99hip || die
+ echo "ROCM_PATH=${EPREFIX}/usr" >> 99hip || die
+ echo "HIP_PLATFORM=rocclr" >> 99hip || die
+ echo "HIP_RUNTIME=ROCclr" >> 99hip || die
+ echo "HIP_COMPILER=clang" >> 99hip || die
+ echo "HIP_CLANG_PATH=${EPREFIX}/usr/lib/llvm/roc/bin" >> 99hip || die
+
+ echo "PATH=${EPREFIX}/usr/lib/hip/bin" >> 99hip || die
+ echo "HIP_PATH=${EPREFIX}/usr/lib/hip" >> 99hip || die
+ echo "LDPATH=${EPREFIX}/usr/lib/hip/lib" >> 99hip || die
+ echo "ROOTPATH=${EPREFIX}/usr/lib/hip/bin" >> 99hip || die
+
+ doenvd 99hip
+
+ cmake_src_install
+}
next reply other threads:[~2021-01-20 5:36 UTC|newest]
Thread overview: 36+ messages / expand[flat|nested] mbox.gz Atom feed top
2021-01-20 5:36 Benda XU [this message]
-- strict thread matches above, loose matches on Subject: below --
2021-08-03 1:35 [gentoo-commits] repo/gentoo:master commit in: dev-util/hip/ Benda XU
2021-08-03 7:04 Benda XU
2022-01-24 14:46 Benda XU
2022-03-05 20:51 Andrew Ammerlaan
2022-03-25 15:52 Benda XU
2022-03-27 3:18 Benda XU
2022-03-27 3:26 Benda XU
2022-06-22 13:03 Benda XU
2022-09-12 8:41 Benda XU
2022-09-12 8:41 Benda XU
2022-10-08 12:40 Arthur Zamarin
2022-12-20 9:26 罗百科
2023-01-31 13:32 Benda XU
2023-01-31 13:32 Benda XU
2023-01-31 13:32 Benda XU
2023-01-31 13:32 Benda XU
2023-01-31 13:32 Benda XU
2023-01-31 13:32 Benda XU
2023-02-22 16:16 Sam James
2023-10-19 10:38 罗百科
2023-10-27 8:14 Andrew Ammerlaan
2023-10-30 9:22 罗百科
2023-11-19 11:30 罗百科
2023-12-14 15:02 Benda XU
2023-12-14 15:02 Benda XU
2023-12-23 10:43 罗百科
2024-01-06 7:21 Sam James
2024-01-06 7:21 Sam James
2024-03-08 19:22 Sam James
2024-03-08 19:22 Sam James
2024-03-08 19:22 Sam James
2024-03-12 2:25 Sam James
2024-06-26 9:21 Sam James
2024-06-26 9:21 Sam James
2024-07-28 8:04 Patrick Lauer
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1611118312.8837056f58be66a4bc0cad115f66264fb8e066d7.heroxbd@gentoo \
--to=heroxbd@gentoo.org \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox